#usage, in foshan ,download build, untar, the reload app
import requests,os,schedule
import subprocess
import tarfile
import shutil
import logging,sys,time
logging.basicConfig(
    filename='autoUpdate.log',  # Specify the log file
    filemode='w',  # Append the log messages to the file
    format='%(asctime)s - %(name)s - %(levelname)s - %(message)s',
    level=logging.DEBUG  # Set the logging level to DEBUG
)
sysapp = logging.getLogger('autoUpdate')

#https://build.epm2demo.cn/cicd_cache/update/cons_build_image
workDir='/home/geoinfo/EPM2'
appDir=f'{workDir}/APP'
devDir=f'{workDir}/DEV'
buildDir=f'${workDir}/UPLOAD/sys'
armMdPath=f'{workDir}/nm_arm.tar'

def untar(tar_file_path, destination_dir):
    with tarfile.open(tar_file_path, 'r') as tar:
        tar.extractall(path=destination_dir)

def job_1():
    url = 'https://build.epm2demo.cn/cicd_cache/update/cons_build_image'
    username = 'epm'
    password = 'Wang_2023'
    sysapp.info(f'Downloading cons_build_image from {url}')
    response = requests.get(url, auth=(username, password),verify=True)

    if response.status_code == 200:
        #cons-build-cons_master_b92aad30_f25e0faa_8cc3d37
        sysapp.info(response.content)
        version = response.content.decode('utf-8').strip('\n')
        sysapp.info('File downloaded successfully')
    else:
        sysapp.info('Failed to download the file')

    fileName=f'{version}-node20.tar'
    sysapp.info(f'File name is {fileName}')

    if not os.path.exists(fileName):
        sysapp.info(f'{fileName} does not exist')

        url = f'https://build.epm2demo.cn/cicd_cache_v20/{fileName}'
        username = 'epm'
        password = 'Wang_2023'

        sysapp.info(f'Downloading {fileName} from {url}')
        response = requests.get(url, auth=(username, password),verify=True)

        if response.status_code == 200:
            with open(f'{buildDir}/{fileName}', 'wb') as f:
                f.write(response.content)
            sysapp.info('File downloaded successfully')
        else:
            sysapp.info('Failed to download the file')
    else:
        sysapp.info(f'{fileName} already exists')

    sysapp.info('untar app')
    shutil.rmtree(os.path.join(appDir, 'node_modules'))
    untar(os.path.join(buildDir, fileName),appDir)
    sysapp.info('load arm module')
    untar(armMdPath,appDir)

    sysapp.info('untar dev')
    shutil.rmtree(os.path.join(devDir, 'node_modules'))
    untar(os.path.join(buildDir, fileName),devDir)
    sysapp.info('load arm module')
    untar(armMdPath,devDir)

    cmd=f"pm2 reload all"
    sysapp.info(cmd)
    result = subprocess.run(cmd, shell=True, capture_output=True, text=True)
    sysapp.info(result) 
    if result.returncode == 0:
        sysapp.info("updateApp success")
        rsp='success'
    else:
        sysapp.error("updateApp fail")

job_1()
# schedule.every().hour.at(":44").do(job_1)

# while True:
#     schedule.run_pending()
#     time.sleep(1)